#include "StdAfx.h"
#include ".\rootcontainer.h"

IMPLEMENT_RTTI(CRootContainer, CContainer)
CRootContainer::CRootContainer()
{
	m_bEventRouteFlag = FALSE;
	m_pFocusedComponent = NULL;
	m_pLastCursorComponent = NULL;
	m_pCapturedComponent = NULL;
	m_hWndOwner = NULL;
	_tcscpy_s(m_szName, MAX_COMPONENT_NAME, _T("document"));
}

CRootContainer::~CRootContainer(void)
{
}
void CRootContainer::Init()
{
	/** {kr} @n
	*	׹ȣ :   @n
	*	 : 2008/06/13 @n
	*	۾ : hhd2002 @n
	*	 : @n
	*		CRootContainer::Init  @n
	*		CRootContainer::Close  @n
	*		CVideoMainWnd::OnDestroy  @n
	*	 : @n
	*		1. ε @n
	*		2.  @n
	*		3. [x] ý۹ư Ŭ @n
	*		4.  @n
	*	 : @n
	*		ᰡ Ǿ WM_DESTROY  ߻, @n
	*		̶ UIƮ ҽ, üҸ, @n
	*		Ŀ WM_KILLFOCUS  ߻.  @n
	*		̶ ֱ Ŀ Ǿ Ʈ(=ư) Ŀ killϱ ؼ, @n
	*		CRootContainer::SetFocus Լ  ̹ ü Ҹ ư ͸ . @n
	*	ذ : @n
	*		CRootContainer  ʱȭ/ó Լ , @n
	*		 Լ鿡 /ÿ   ʱȭ . @n
	*		װ ߻ߴ  ȭ   üũ ó ƾ ó  . @n
	* {/kr} */
	m_bEventRouteFlag = TRUE;
	m_pFocusedComponent = NULL;
	m_pLastCursorComponent = NULL;
	m_pCapturedComponent = NULL;
}
void CRootContainer::Close()
{
	m_bEventRouteFlag = FALSE;
	m_pFocusedComponent = NULL;
	m_pLastCursorComponent = NULL;
	m_pCapturedComponent = NULL;
}
CComponent* CRootContainer::SetFocus(CComponent* pFocusComponent)
{
	ATLASSERT(IsWindow(m_hWndOwner));
	CComponent* pPrevFocusedComponent = m_pFocusedComponent;
	if (pPrevFocusedComponent == pFocusComponent)
	{
		return m_pFocusedComponent;
	}
	if (pFocusComponent)
	{
		::SetFocus(m_hWndOwner);
	}
	m_pFocusedComponent = pFocusComponent;
	if (pPrevFocusedComponent != NULL)
	{
		pPrevFocusedComponent->OnKillFocus(m_pFocusedComponent);
	}
	if (m_pFocusedComponent != NULL)
	{
		m_pFocusedComponent->OnSetFocus(pPrevFocusedComponent);
	}
	return pPrevFocusedComponent;
	/*
	ATLASSERT(IsWindow(m_hWndOwner));
	::SetFocus(m_hWndOwner);

	CComponent* pPrevFocusedComponent = m_pFocusedComponent;
	if (pPrevFocusedComponent != pFocusComponent)
	{
		m_pFocusedComponent = pFocusComponent;
	}
	*/
	return m_pFocusedComponent;
}
CComponent* CRootContainer::GetFocus()
{
	return m_pFocusedComponent;
}
CComponent* CRootContainer::SetLastCursorComponent(CComponent* pLastCursorComponent)
{
	if (m_pLastCursorComponent == pLastCursorComponent) return m_pLastCursorComponent;

	CComponent* pPrevLastCursorComponent = m_pLastCursorComponent;
	if (pPrevLastCursorComponent)
	{
		pPrevLastCursorComponent->OnMouseLeave();
	}
	m_pLastCursorComponent = pLastCursorComponent;
	return pPrevLastCursorComponent;
}
CComponent* CRootContainer::GetLastCursorComponent()
{
	return m_pLastCursorComponent;
}
BOOL CRootContainer::SetCapturedComponent(CComponent* pCapturedComponent)
{
	m_pCapturedComponent = pCapturedComponent;
	return TRUE;
}
CComponent*	CRootContainer::GetCapturedComponent()
{
	return m_pCapturedComponent;
}
HWND CRootContainer::SetOwner(HWND hWndOwner)
{
	ATLASSERT(IsWindow(hWndOwner));
	HWND hWndPrev = m_hWndOwner;
	m_hWndOwner = hWndOwner;

	/* {kr}
		Ŵ  θ츦 .
		
		Ŵ θ ڵ  ϰ ִٰ 
		νϽ ó  ϰ Ǹ
		Ŵ  lazy initialize .
	{/kr} */
	m_ToolTipMgr.SetParent(hWndOwner);

	return hWndPrev;
}
HWND CRootContainer::GetOwner()
{
	return m_hWndOwner;
}
CNToolTipMgr* CRootContainer::GetToolTipMgr()
{
	return &m_ToolTipMgr;
}
BOOL CRootContainer::_IsMouseMessage(UINT uMsg)
{
	/// {kr}  ޽ 콺 ޽ . {/kr}@n
	return (uMsg >= WM_MOUSEFIRST && uMsg <= WM_MOUSELAST);
}